dim LogFile as QFileStream
dim ExtractedFile as QFileStream
dim lingua(100) as string
dim RecordType(6) as string
Dim FileType(6) as string
dim OptionType(16) as string
dim SISType(6) as string
dim NUM_MODELS AS byte
dim ZLib(10) as string
dim gzip_header as string

gzip_header=chr$(31)+chr$(139)+chr$(8)+chr$(0)+chr$(0)+chr$(0)+chr$(0)+chr$(0)+chr$(0)+chr$(11)

NUM_MODELS=30
dim Model(NUM_MODELS,2) as string

lingua(0)="Test"
lingua(1)="EN-UK English"
lingua(2)="FR-French"
lingua(3)="GE-German"
lingua(4)="SP-Spanish"
lingua(5)="IT-Italian"
lingua(6)="SW-Swedish"
lingua(7)="DA-Danish"
lingua(8)="NO-Norwegian"
lingua(9)="FI-Finnish"
lingua(10)="AM-American English"
lingua(11)="SF-Swiss French"
lingua(12)="SG-Swiss German"
lingua(13)="PO-Portuguese"
lingua(14)="TU-Turkish"
lingua(15)="IC-Icelandic"
lingua(16)="RU-Russian"
lingua(17)="HU-Hungarian"
lingua(18)="DU-Dutch"
lingua(19)="BL-Belgian Flemish"
lingua(20)="AU-Australian English"
lingua(21)="BG-Belgian French"
lingua(22)="AS-Austrian German"
lingua(23)="NZ-New Zealand English"
lingua(24)="IF-International French"
lingua(25)="CS-Czech"
lingua(26)="SK-Slovak"
lingua(27)="PL-Polish"
lingua(28)="SL-Slovenian"
lingua(29)="TC-Taiwan Chinese"
lingua(30)="HK-Hong Kong Chinese"
lingua(31)="ZH-PRC Chinese"
lingua(32)="JA-Japanese"
lingua(33)="TH-Thai"
lingua(34)="AF-Afrikaans"
lingua(35)="SQ-Albanian"
lingua(36)="AH-Amharic"
lingua(37)="AR-Arabic"
lingua(38)="HY-Armenian"
lingua(39)="TL-Tagalog"
lingua(40)="BE-Belarussian"
lingua(41)="BN-Bengali"
lingua(42)="BG-Bulgarian"
lingua(43)="MY-Burmese"
lingua(44)="CA-Catalan"
lingua(45)="HR-Croatian"
lingua(46)="CE-Canadian English"
lingua(47)="IE-International English"
lingua(48)="SF-South African English"
lingua(49)="ET-Estonian"
lingua(50)="FA-Farsi"
lingua(51)="CF-Canadian French"
lingua(52)="GD-Scots Gaelic"
lingua(53)="KA-Georgian"
lingua(54)="EL-Greek"
lingua(55)="CG-Cyprus Greek"
lingua(56)="GU-Gujarati"
lingua(57)="HE-Hebrew"
lingua(58)="HI-Hindi"
lingua(59)="IN-Indonesian"
lingua(60)="GA-Irish"
lingua(61)="SZ-Swiss Italian"
lingua(62)="KN-Kannada"
lingua(63)="KK-Kazakh"
lingua(64)="KM-Khmer"
lingua(65)="KO-Korean"
lingua(66)="LO-Laothian"
lingua(67)="LV-Latvian"
lingua(68)="LT-Lithuanian"
lingua(69)="MK-Macedonian"
lingua(70)="MS-Malay"
lingua(71)="ML-Malayalam"
lingua(72)="MR-Marathi"
lingua(73)="MO-Moldavian"
lingua(74)="MN-Mongolian"
lingua(75)="NN-Norwegian-Nynorsk"
lingua(76)="BP-Brazilian Portuguese"
lingua(77)="PA-Punjabi"
lingua(78)="RO-Romanian"
lingua(79)="SR-Serbian"
lingua(80)="SI-Sinhalese"
lingua(81)="SO-Somali"
lingua(82)="OS-International Spanish"
lingua(83)="LS-Latin American Spanish"
lingua(84)="SH-Swahili"
lingua(85)="FS-Finland Swedish"
lingua(87)="TA-Tamil"
lingua(88)="TE-Telugu"
lingua(89)="BO-Tibetan"
lingua(90)="TI-Tigrinya"
lingua(91)="CT-Cyprus Turkish"
lingua(92)="TK-Turkmen"
lingua(93)="UK-Ukrainian"
lingua(94)="UR-Urdu"
lingua(96)="VI-Vietnamese"
lingua(97)="CY-Welsh"
lingua(98)="ZU-Zulu"


RecordType(0)="Simple file line	"
RecordType(1)="Multiple language files line	"
RecordType(2)="Options line	"
RecordType(3)="If line	"
RecordType(4)="ElseIf line	"
RecordType(5)="Else line	"
RecordType(6)="EndIf line"

FileType(1)="Standard file (the default)	"
FileType(2)="Text file to display during installation	"
FileType(3)="SIS component file	"
FileType(4)="File to be run during installation and/or removal	"
FileType(5)="File does not yet exist, but will be created when the application is run	"
FileType(6)="Open file"


Model(1,1)="Series 60 v0.9": model (1,2)="101F6F88"
Model(2,1)="Series 60 v1.0": model (2,2)="101F795F"
Model(3,1)="Series 60 v1.1": model (3,2)="101F8201"
Model(4,1)="Series 60 v1.2": model (4,2)="101F8202"
Model(5,1)="Series 60 v2.0": model (5,2)="101f7960"
Model(6,1)="Series 60 2nd Edition": model (6,2)="101f7960"
Model(7,1)="Series 60 2nd Edition + Feature Pack 1": model (7,2)="101F9115"
Model(8,1)="Series 60 2nd Edition + Feature Pack 2": model (8,2)="10200BAB"
Model(9,1)="Nokia 3650": 	model (9,2)="101F7962"
Model(10,1)="Nokia 6600": model (10,2)="101F7963"
Model(11,1)="Nokia 6620": model (11,2)="1020216B"
Model(12,1)="Nokia 6630": model (12,2)="101F7964"
Model(13,1)="Nokia 6680": model (13,2)="10200f99"
Model(14,1)="Nokia 7610": model (14,2)="101FD5DB"
Model(15,1)="Nokia 7650": model (15,2)="101F6F87"
Model(16,1)="Nokia N-Gage":      model (16,2)="101F8A64"
Model(17,1)="Siemens SX1":       model (17,2)="101F9071"
Model(18,1)="Series 80 v2.0":    model (18,2)="101F8ED2"
Model(19,1)="Nokia 9300":			   model (19,2)="101F8ED1"
Model(20,1)="Nokia 9500":			   model (20,2)="101F8DDB"
Model(21,1)="UIQ v2.0":          model (21,2)="101F617B"
Model(22,1)="UIQ v2.1": 			   model (22,2)="101F61CE"
Model(23,1)="SonyEricsson P80x": model (23,2)="101F80BE"
Model(24,1)="SonyEricsson P90x": model (24,2)="101FBB35"
Model(25,1)="Series5mx": 				 model (25,2)="1000118a"
Model(26,1)="Brutus board": 		 model (26,2)="10005f60"
Model(27,1)="Cogent board": 		 model (27,2)="10005f61"
Model(28,1)="Win32Emulator":		 model (28,2)="10005f62"
Model(29,1)="WinC": 						 model (29,2)="10005f63"
Model(30,1)="CirrusLogic 7211 board": model (30,2)="1000604f"


OptionType(1)="IU		IsUnicode (EPOC release 5)"
OptionType(2)="ID		IsDistributable (EPOC release 5)	"
OptionType(8)="NC	NOCOMPRESS	NoCompress (EPOC release 6)	"
OptionType(16)="SH	SHUTDOWNAPPS	ShutdownApps (EPOC release 6)"

' SISType is ZERO based:
SISType(1) = "SA	SISAPP	Contains an application (the default)	"
SISType(2) = "SY	SISSYSTEM	Contains a shared/system component such as a DLL or OPX (EPOC release 6)	"
SISType(3) = "SO	SISOPTION	Contains an optional component, independently selectable by the user (EPOC release 6)	"
SISType(4) = "SC	SISCONFIG	Configures an existing application or service (EPOC release 6)	"
SISType(5) = "SP	SISPATCH	Patches an existing component (EPOC release 6)	"
SISType(6) = "SU	SISUPGRADE	Upgrades an existing component (EPOC release 6)"

ZLib(1)= " ZLIB ERROR -6 --> VERSION ERROR <--"
ZLib(2)= " ZLIB ERROR -5 --> BUFFER ERROR <--"
ZLib(3)= " ZLIB ERROR -4 --> MEMORY ERROR <--"
ZLib(4)= " ZLIB ERROR -3 --> DATA ERROR <--"
ZLib(5)= " ZLIB ERROR -2 --> STREAM ERROR <--"
ZLib(6)= " ZLIB ERROR -1 --> ERRNO ERROR <--"
ZLib(7)= " ZLIB - --==> Succesful uncompression <==--"
ZLib(8)= " ZLIB Message 1 --> STREAM END  <--"
ZLib(9)= " ZLIB Message 2 --> NEED DICT  <--"



dim uid1 as long
dim uid2 as long
dim uid3 as long
dim uid4 as long
dim Checksum as long
dim languages as long
dim files as long
dim requisites as long
dim Installation_language as long
dim Installation_files as long
dim Installation_drive as long
dim capabilities as long
dim Installer_version as long
dim Options2 as long
dim Type2 as long
dim Major_version as long
dim Minor_version as long
dim Variant2 as long
dim Languages_pointer as long
dim Files_pointer as long
dim Requisites_pointer as long
dim Certificates_pointer as long
dim Component_name_pointer as long
dim Signature_pointer as long
dim Installed_space as long
dim Maximum_installed_space as long
dim reserved as long
dim Capabilities_pointer as long
dim AppName as string
dim ExtractedFileNameFull as string
dim FakeFiles as long
dim Extract as byte
dim crc32path as string
dim crc32line as string
dim crc32row as string

' *******  Main offsets *****
uid1 = 00
uid2 = 04
uid3 = 08
uid4 =  12
Checksum = 16
languages = 18
files = 20
requisites = 22
Installation_language = 24
Installation_files = 26
Installation_drive = 28
capabilities = 30
Installer_version = 32
Options2 = 36
Type2 = 38
Major_version = 40
Minor_version = 42
Variant2 = 44
Languages_pointer = 48
Files_pointer = 52
Requisites_pointer = 56
Certificates_pointer = 60
Component_name_pointer = 64
Signature_pointer	= 68
Capabilities_pointer = 72
Installed_space	= 76
Maximum_installed_space = 80
Reserved = 84

dim w as word
dim b as byte
dim l as long

dim conta as byte
dim trovato as byte
dim SISversion as byte
dim NumLang as long
dim PointLang as long
dim x as long
dim NumFiles as long
dim PointFiles as long
dim NameLength as long
dim PointAppName as long
dim LenAppName as long
dim PointAppNameActual as long
dim PointCapab as long
dim Value as long
dim ModelUID as long
dim FileTypeAlt as long
dim FileRecordType as long
dim LanguageOffset as long
dim AppNameLength as long
dim AppNamePointer as Long
dim ComponentNameBeginning as long
dim ExtractedFileName as string
dim ExtractedFileLength as long
dim ExtractedFilePointer as long
dim RecLen as long
dim OpenDialog as QOpenDialog
dim SISFile as qfilestream
dim LocalNumLang as long
dim Compressed as long
dim OriginalFileSize as long
dim UncompressResult as long
dim CurrentLang as long
dim temp as long

